export type { Process, ProcessID, ProcessAccessor } from './types';
import { GenServerDefinition } from './GenServer';
import { BusAPI } from './Bus';
export declare const Utils: {
    isNil: (v: any) => boolean;
    defaultTo: (defaultValue: any, actualValue: any) => any;
    is: (constructor: any, val: any) => boolean;
    isFunction: (val: any) => boolean;
    isString: (val: any) => boolean;
    isArray: (val: any) => boolean;
    filter: (cb: (v: any) => boolean, val: any) => {};
    fromPairs: (arr: []) => {};
    toPairs: (obj: object) => any[];
    assoc: (path: string, val: any, obj: object) => {};
    drop: (n: number, from: []) => never[];
    prop: (key: string, obj: object) => any;
    contains: (value: any, list: []) => boolean;
    equals: (a: any, b: any, c?: any[] | undefined) => boolean;
    map: (f: (v: any) => any, element: any) => {};
    reduce: (cb: any, initial: any, iterable: any) => any;
    mountNamespace: (name: string, value: any) => void;
};
export declare const create: (process: import("./types").Process) => number;
export declare const call: (pid: number, message: any) => any;
export declare const cast: (pid: number, message: any) => number;
export declare const destroy: (pid: number) => void;
export declare const GenServer: ({ name, castHandlers, callHandlers, initialState }: GenServerDefinition) => any;
export declare const Registry: {
    create: (process: number, name: string) => any;
    lookup: (name: string) => any;
};
export declare const State: {
    getState: (scope: string, busName: string) => any;
    set: (name: string, value: any) => void;
    unset: (name: string) => void;
    get: (name?: string | null) => any;
};
export declare const Bus: BusAPI;
declare let result: any;
export declare const mount: () => void;
export default result;
